%token <string> VAR
%token <int> INT
%token <float> FLT
%token EQ LET IN ADD MIN MUL DIV
%token LPAREN RPAREN
%token EOF
%left ADD MIN        /* lowest precedence */
%left MUL DIV
%start main             /* the entry point */
%type <Question10.expr> main
%%
main:
expr EOF                { $1 };

expr:
  | LET VAR EQ expr IN expr { Question10.Let ($2,$4,$6) }
  | sexpr                   { $1 }
;

sexpr:
  | sexpr ADD sexpr         { Question10.Op($1,"+",$3) }
  | sexpr MIN sexpr         { Question10.Op($1,"-",$3) }
  | mexpr                   { $1 }
;

mexpr:
  | mexpr MUL mexpr         { Question10.Op($1,"*",$3) }
  | mexpr DIV mexpr         { Question10.Op($1,"/",$3) }
  | VAR                     { Question10.Var $1 }
  | value                   { Question10.Val $1 }
  | LPAREN expr RPAREN      { $2 }
;

value:
  | INT                     { Question10.Int $1 }
  | FLT                     { Question10.Float $1 }
;
