(* EPITA SPE 2010/2011        *)
(* Contrôle 1 - Novembre 2010 *)
(* question07 - test          *)

module Q = Question07

let rec gen_list f = function
    n when n<1 -> []
  | 1 -> f () :: []
  | n -> f () :: gen_list f (Random.int (n - 1))

let make_tree q l =
  let rec aux = function
      -1 -> Q.Empty
    | 0 -> Q.Node(q#getN, [])
    | d -> Q.Node(q#getN, gen_list (fun _ -> aux (d-1)) l)
  in aux q#getSize

let rec print = function
    Q.Empty -> ()
  | Q.Node(k,sons) ->
      begin
	Format.printf "@[<b 2>(%02d@," k;
	List.iter print sons;
	Format.printf ")@]@,"
      end

let to_dot out t =
  let c = ref 0 in
  let uniq () =
    incr c;
    Printf.sprintf "node%d" !c
  in
  let rec aux id = function
      Q.Empty -> ()
    | Q.Node(k,sons) ->
	begin
	  Format.fprintf out "@,@[<b>%s [label=\"%02d\"];@]" id k;
	  List.iter (
	    function
		Q.Empty -> ()
	      | son ->
		  let sid = uniq () in
		    Format.fprintf out "@,%s -- %s;" id sid;
		    aux sid son
	  ) sons;
	end
  in
    begin
      Format.fprintf out "@[<v>graph a {@[<v>";
      aux (uniq ()) t;
      Format.fprintf out "@]@,}@]@."
    end

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 7 32 in
      q#beginParse;
      q#init;
      let t = make_tree q 5 in
      let out = open_out "q07_tree.dot" in
	to_dot (Format.formatter_of_out_channel out) t;
	close_out out;
	Format.printf "@[<v 2>t =@;";
	print t;
	Format.printf "@]@.@.";
	Format.printf "@[<b 2>to_list [] t =@;";
	Test_frame.printList Test_frame.i2s (Q.to_list [] t);
	Format.printf "@]@.";
	exit 0
  end

let _ = main ()
